mia-3dcost-translatedgrad(1)

NAME
mia-3dcost-translatedgrad - Evaluate the cost gradient between two images and convert it to a spline representation.

SYNOPSIS
mia-3dcost-translatedgrad -i <in-file> -r <ref-file> -o <out-file> [options]

DESCRIPTION
mia-3dcost-translatedgrad Evaluate the cost gradient between two images and evaluate the transformation related gradient for it based on the given transformation model.

OPTIONS

    -i --in-file=(input, required); io
        input image
         For supported file types see PLUGINS:3dimage/io

    -r --ref-file=(input, required); io
        reference image
         For supported file types see PLUGINS:3dimage/io

    -o --out-file=(output, required); io
        output vector field
         For supported file types see PLUGINS:3dtransform/io

    -g --gradimg-file=(output); io
        norm image of the spline transformed gradient
         For supported file types see PLUGINS:3dimage/io

    -C --cost-gradimg-file=(output); io
        norm image of the cost gradient
         For supported file types see PLUGINS:3dimage/io

    -f --transForm=spline:rate=5
        Transformation the gradient relates to
         For supported plugins see PLUGINS:3dimage/transform

    -c --cost=ssd
        cost function to use
         For supported plugins see PLUGINS:3dimage/cost

  Help & Info

    -V --verbose=warning
        verbosity of output, print messages of given level and higher priorities. Supported priorities starting at lowest level are:

        trace - Function call trace
        debug - Debug output
        info - Low level messages
        message - Normal messages
        warning - Warnings
        fail - Report test failures
        error - Report errors
        fatal - Report only fatal errors

    --copyright
        print copyright information

    -h --help
        print this help

    -? --usage
        print a short help

    --version
        print the version number and exit

  Processing

    --threads=-1
        Maxiumum number of threads to use for processing,This number should be lower or equal to the number of logical processor cores in the machine. (-1: automatic estimation).

PLUGINS: 1d/splinebc

mirror
    Spline interpolation boundary conditions that mirror on the boundary

    (no parameters)

repeat
    Spline interpolation boundary conditions that repeats the value at the boundary

    (no parameters)

zero
    Spline interpolation boundary conditions that assumes zero for values outside

    (no parameters)

PLUGINS: 1d/splinekernel

bspline
    B-spline kernel creation , supported parameters are:

    d = 3; int in [0, 5]
        Spline degree.

omoms
    OMoms-spline kernel creation, supported parameters are:

    d = 3; int in [3, 3]
        Spline degree.

PLUGINS: 3dimage/cost

lncc
    local normalized cross correlation with masking support., supported parameters are:

    w = 5; uint in [1, 256]
        half width of the window used for evaluating the localized cross correlation.

mi  Spline parzen based mutual information., supported parameters are:

    cut = 0; float in [0, 40]
        Percentage of pixels to cut at high and low intensities to remove outliers.

    mbins = 64; uint in [1, 256]
        Number of histogram bins used for the moving image.

    mkernel = [bspline:d=3]; factory
        Spline kernel for moving image parzen hinstogram. For supported plug-ins see PLUGINS:1d/splinekernel

    rbins = 64; uint in [1, 256]
        Number of histogram bins used for the reference image.

    rkernel = [bspline:d=0]; factory
        Spline kernel for reference image parzen hinstogram. For supported plug-ins see PLUGINS:1d/splinekernel

ncc normalized cross correlation.

    (no parameters)

ngf This function evaluates the image similarity based on normalized gradient fields. Given normalized gradient fields $ _S$ of the src image and $ _R$ of the ref image various evaluators are implemented., supported parameters are:

    eval = ds; dict
        plugin subtype (sq, ds,dot,cross). Supported values are:
            ds - square of scaled difference
            dot - scalar product kernel
            cross - cross product kernel

ssd 3D image cost: sum of squared differences, supported parameters are:

    autothresh = 0; float in [0, 1000]
        Use automatic masking of the moving image by only takeing intensity values into accound that are larger than the given threshold.

    norm = 0; bool
        Set whether the metric should be normalized by the number of image pixels.

ssd-automask
    3D image cost: sum of squared differences, with automasking based on given thresholds, supported parameters are:

    rthresh = 0; double
        Threshold intensity value for reference image.

    sthresh = 0; double
        Threshold intensity value for source image.

PLUGINS: 3dimage/io

analyze
    Analyze 7.5 image

    Recognized file extensions: .HDR, .hdr

    Supported element types:
        unsigned 8 bit, signed 16 bit, signed 32 bit, floating point 32 bit, floating point 64 bit

datapool
    Virtual IO to and from the internal data pool

    Recognized file extensions: .@

dicom
    Dicom image series as 3D

    Recognized file extensions: .DCM, .dcm

    Supported element types:
        signed 16 bit, unsigned 16 bit

hdf5
    HDF5 3D image IO

    Recognized file extensions: .H5, .h5

    Supported element types:
        binary data, signed 8 bit, unsigned 8 bit, signed 16 bit, unsigned 16 bit, signed 32 bit, unsigned 32 bit, signed 64 bit, unsigned 64 bit, floating point 32 bit, floating point 64 bit

inria
    INRIA image

    Recognized file extensions: .INR, .inr

    Supported element types:
        signed 8 bit, unsigned 8 bit, signed 16 bit, unsigned 16 bit, signed 32 bit, unsigned 32 bit, floating point 32 bit, floating point 64 bit

mhd MetaIO 3D image IO using the VTK implementation (experimental).

    Recognized file extensions: .MHA, .MHD, .mha, .mhd

    Supported element types:
        signed 8 bit, unsigned 8 bit, signed 16 bit, unsigned 16 bit, signed 32 bit, unsigned 32 bit, floating point 32 bit, floating point 64 bit

nifti
    NIFTI-1 3D image IO. The orientation is transformed in the same way like it is done with 'dicomtonifti --no-reorder' from the vtk-dicom package.

    Recognized file extensions: .NII, .nii

    Supported element types:
        signed 8 bit, unsigned 8 bit, signed 16 bit, unsigned 16 bit, signed 32 bit, unsigned 32 bit, signed 64 bit, unsigned 64 bit, floating point 32 bit, floating point 64 bit

vff VFF Sun raster format

    Recognized file extensions: .VFF, .vff

    Supported element types:
        unsigned 8 bit, signed 16 bit

vista
    Vista 3D

    Recognized file extensions: .-, .V, .VISTA, .v, .vista

    Supported element types:
        binary data, signed 8 bit, unsigned 8 bit, signed 16 bit, unsigned 16 bit, signed 32 bit, unsigned 32 bit, floating point 32 bit, floating point 64 bit

vti 3D image VTK-XML in- and output (experimental).

    Recognized file extensions: .VTI, .vti

    Supported element types:
        signed 8 bit, unsigned 8 bit, signed 16 bit, unsigned 16 bit, signed 32 bit, unsigned 32 bit, floating point 32 bit, floating point 64 bit

vtk 3D VTK image legacy in- and output (experimental).

    Recognized file extensions: .VTK, .VTKIMAGE, .vtk, .vtkimage

    Supported element types:
        signed 8 bit, unsigned 8 bit, signed 16 bit, unsigned 16 bit, signed 32 bit, unsigned 32 bit, floating point 32 bit, floating point 64 bit

PLUGINS: 3dimage/transform

affine
    Affine transformation (12 degrees of freedom), supported parameters are:

    imgboundary = mirror; factory
        image interpolation boundary conditions. For supported plug-ins see PLUGINS:1d/splinebc

    imgkernel = [bspline:d=3]; factory
        image interpolator kernel. For supported plug-ins see PLUGINS:1d/splinekernel

axisrot
    Restricted rotation transformation (1 degrees of freedom). The transformation is restricted to the rotation around the given axis about the given rotation center, supported parameters are:

    axis =(required, 3dfvector)
        rotation axis.

    imgboundary = mirror; factory
        image interpolation boundary conditions. For supported plug-ins see PLUGINS:1d/splinebc

    imgkernel = [bspline:d=3]; factory
        image interpolator kernel. For supported plug-ins see PLUGINS:1d/splinekernel

    origin =(required, 3dfvector)
        center of the transformation.

raffine
    Restricted affine transformation (3 degrees of freedom). The transformation is restricted to the rotation around the given axis and shearing along the two axis perpendicular to the given one, supported parameters are:

    axis =(required, 3dfvector)
        rotation axis.

    imgboundary = mirror; factory
        image interpolation boundary conditions. For supported plug-ins see PLUGINS:1d/splinebc

    imgkernel = [bspline:d=3]; factory
        image interpolator kernel. For supported plug-ins see PLUGINS:1d/splinekernel

    origin =(required, 3dfvector)
        center of the transformation.

rigid
    Rigid transformation, i.e. rotation and translation (six degrees of freedom)., supported parameters are:

    imgboundary = mirror; factory
        image interpolation boundary conditions. For supported plug-ins see PLUGINS:1d/splinebc

    imgkernel = [bspline:d=3]; factory
        image interpolator kernel. For supported plug-ins see PLUGINS:1d/splinekernel

    origin = [[0,0,0]]; 3dfvector
        Relative rotation center, i.e. <0.5,0.5,0.5> corresponds to the center of the volume.

rotation
    Rotation transformation (three degrees of freedom)., supported parameters are:

    imgboundary = mirror; factory
        image interpolation boundary conditions. For supported plug-ins see PLUGINS:1d/splinebc

    imgkernel = [bspline:d=3]; factory
        image interpolator kernel. For supported plug-ins see PLUGINS:1d/splinekernel

    origin = [[0,0,0]]; 3dfvector
        Relative rotation center, i.e. <0.5,0.5,0.5> corresponds to the center of the volume.

rotbend
    Restricted transformation (4 degrees of freedom). The transformation is restricted to the rotation around the x and y axis and a bending along the x axis, independedn in each direction, with the bending increasing with the squared distance from the rotation axis., supported parameters are:

    imgboundary = mirror; factory
        image interpolation boundary conditions. For supported plug-ins see PLUGINS:1d/splinebc

    imgkernel = [bspline:d=3]; factory
        image interpolator kernel. For supported plug-ins see PLUGINS:1d/splinekernel

    norot = 0; bool
        Don't optimize the rotation.

    origin =(required, 3dfvector)
        center of the transformation.

spline
    Free-form transformation that can be described by a set of B-spline coefficients and an underlying B-spline kernel., supported parameters are:

    anisorate = [[0,0,0]]; 3dfvector
        anisotropic coefficient rate in pixels, nonpositive values will be overwritten by the 'rate' value..

    debug = 0; bool
        enable additional debugging output.

    imgboundary = mirror; factory
        image interpolation boundary conditions. For supported plug-ins see PLUGINS:1d/splinebc

    imgkernel = [bspline:d=3]; factory
        image interpolator kernel. For supported plug-ins see PLUGINS:1d/splinekernel

    kernel = [bspline:d=3]; factory
        transformation spline kernel. For supported plug-ins see PLUGINS:1d/splinekernel

    penalty = ; factory
        transformation penalty energy term. For supported plug-ins see PLUGINS:3dtransform/splinepenalty

    rate = 10; float in [1, inf)
        isotropic coefficient rate in pixels.

translate
    Translation (three degrees of freedom), supported parameters are:

    imgboundary = mirror; factory
        image interpolation boundary conditions. For supported plug-ins see PLUGINS:1d/splinebc

    imgkernel = [bspline:d=3]; factory
        image interpolator kernel. For supported plug-ins see PLUGINS:1d/splinekernel

vf  This plug-in implements a transformation that defines a translation for each point of the grid defining the domain of the transformation., supported parameters are:

    imgboundary = mirror; factory
        image interpolation boundary conditions. For supported plug-ins see PLUGINS:1d/splinebc

    imgkernel = [bspline:d=3]; factory
        image interpolator kernel. For supported plug-ins see PLUGINS:1d/splinekernel

PLUGINS: 3dtransform/io

bbs Binary (non-portable) serialized IO of 3D transformations

    Recognized file extensions: .bbs

datapool
    Virtual IO to and from the internal data pool

    Recognized file extensions: .@

vista
    Vista storage of 3D transformations

    Recognized file extensions: .v, .v3dt

xml XML serialized IO of 3D transformations

    Recognized file extensions: .x3dt

PLUGINS: 3dtransform/splinepenalty

divcurl
    divcurl penalty on the transformation, supported parameters are:

    curl = 1; float in [0, inf)
        penalty weight on curl.

    div = 1; float in [0, inf)
        penalty weight on divergence.

    norm = 0; bool
        Set to 1 if the penalty should be normalized with respect to the image size.

    weight = 1; float in (0, inf)
        weight of penalty energy.

EXAMPLE
Evaluate the SSD cost between src.v and ref.v and store the gradient gradient corresponding to a spline transformation in grad.v3dt.

mia-3dcost-translatedgrad -i src.v -o grad.v3dt -f spline:rate=8 -c ssd

AUTHOR(s)
Gert Wollny

COPYRIGHT
This software is Copyright (c) 1999-2015 Leipzig, Germany and Madrid, Spain. It comes with ABSOLUTELY NO WARRANTY and you may redistribute it under the terms of the GNU GENERAL PUBLIC LICENSE Version 3 (or later). For more information run the program with the option '--copyright'.